//genMethods "-g" "-t" "AttributeBase*" "-I" "LINK/graph/Attribute.h" "-d" "graph" "-y" "display_attributeptr" "-m" "mark_attributeptr" "-w" "free_attributeptr" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>
#include <LINK/graph/Attribute.h>
#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
void display_attributeptr(SCM, SCM, int);
void mark_attributeptr(SCM);
void free_attributeptr(SCM);
typedef AttributeBase* _AttributeBase_;
#define _AttributeBase_DATA(x) ((AttributeBase**) (EXTDATA(x)))
#define _AttributeBase_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<AttributeBase* >::type))
#define _AttributeBase_ISNT_DATA(x) (!IS_DATA(x))
#define _AttributeBase_CXX_DATA(x) (*(AttributeBase**) (EXTDATA(VAL(x))))
#define _AttributeBase_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<AttributeBase* >::type))
#define _AttributeBase_CXX_ISNT_DATA(x) (!CXX_IS_DATA(x))
#include<strstream.h>
void display_attributeptr(SCM c, SCM port, int mode)
{
        ostrstream oss;
	if (*_AttributeBase_DATA(c))
        oss << **_AttributeBase_DATA(c);
        oss << ends;
        char *buffer = oss.str();
        Puts(buffer, (port));
        delete buffer;
}
void mark_attributeptr(SCM p)
{
        //cout << "mark_attributeptr" << endl;
        Register<AttributeBase>::markEntry(*_AttributeBase_DATA(p));
}
void free_attributeptr(SCM p)
{
        //cout << "free_attributeptr" << endl;
        if (!EXTSTATICP(p)) {
                delete _AttributeBase_DATA(p);
        }
}
// define your new methods above 
// and register them using STk_add_new_cpp_primitive() below
void genExtra_AttributeBase_Methods() {}
